Subject: Re: [BUG] "git diff --word-diff" gives a diff while they are only space changes

From: Vincent Lefevre <[email-masked]>
Date: Sat, 9 May 2026 17:55:26 +0200

On 2026-05-09 08:16:48 +0200, Johannes Sixt wrote:
> Am 08.05.26 um 23:39 schrieb Vincent Lefevre:
> > On 2026-05-08 14:48:01 +0200, Johannes Sixt wrote:
> >> This is expected behavior.
> >>
> >> git diff --word-diff is not agnostic to whitespace; if you drop
> >> --word-diff, you see the line-diff that the word-diff is based on. If
> >> you want whitespace-agnostic word-diff, you have to add -w.
> > 
> > This is not how it is documented. Even when using "git diff" without
> > --word-diff, but with GNU wdiff instead, the output is fine:
> > 
> > $ git diff file1 file2 | wdiff -d
> > diff --git a/file1 b/file2
> > index da04344..0074613 100644
> > [--- a/file1-]
> > {+++ b/file2+}
> > @@ -1,5 +1,5 @@
> > 1
> >  2
> >  3
> >  2
> >  4
> 
> It would have helped if you had pointed to, or cited, the documentation.
> I cannot find documentation from which I can derive that the above
> *must* be the correct output. In particular, I don't find any mention
> that --word-diff operates exactly like GNU wdiff.

For wdiff, it is just described as "display word differences between
text files", and it does exactly that. For instance, if there are no
differences in words, it shows no differences.

For git with the --word-diff, there is actually no documentation,
except the use of "changed words" and "word diff". No mention of
line diff at all! So this is quite confusing.

Note: This isn't even a line-based diff with highlighted word diff
as done by some tools, such as Emacs diff-mode.

-- 
Vincent Lefèvre <[email-masked]> - Web: <https://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <https://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / Pascaline project (LIP, ENS-Lyon)